# 
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

use strict;
use CGI qw(:standard);
use CGI::Carp;
use Cwd;
use Data::Dumper;
use XJDParser;

my $cgi = new CGI;

print $cgi->header();
print $cgi->start_html(-title=>'XJD creation page',
                       -author=>'iyoon@cs.umd.edu',
                       -base=>'true',
                       -meta=>{'copyright'=>'copyright 2005 University of Maryland, College Park'}, -script=>{-language=>'JAVASCRIPT',
                                 -src=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/util.js"}
                       );

print "<h3>Defined elements</h3>";

my $sessionid = $cgi->cookie('sessionID');
my $prevXJD = undef;

if(-e "$ENV{HTDOCS_HOME}/HPCALE_XJDHELPER/sessions/$sessionid.xjd"){
    # WIERDO
    # We need one command (such as touch) before prevXJD read. 
    # If not, this frame will not be read correctly.
    # I don't know why until now. :(
    # IE 6.0 shows correct result without this dummy command
    # However, Firefox in windows XP does not.
    `touch $ENV{HTDOCS_HOME}/HPCALE_XJDHELPER/sessions/$sessionid.xjd`;

    $prevXJD = new XJDParser("$ENV{HTDOCS_HOME}/HPCALE_XJDHELPER/sessions/$sessionid.xjd", 2);

    &showComponents($prevXJD, 1);
    print $cgi->hr();
    &showConnections($prevXJD, 1);
    
    print "Session: $sessionid<br>";
    print $cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/sessions/$sessionid.xjd",
                   -target=>'main'},"Show/download XJD");
    print "<br>";    
}
else{
    &showComponents($prevXJD, 0);
    print $cgi->hr();
    &showConnections($prevXJD, 0);

    print "Session: $sessionid<br>";
}
    
print $cgi->end_html;

sub showNewComp {
    print "<ul>";
    print "<li>";
    my $newloc = "https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}".
                 "/cgi-bin/HPCALE_XJDHELPER/gen_manual.cgi?".
                 "mode=mannew&eletype=component";
    print $cgi->a({-href=>"$newloc", -target=>'main'}, "new comp (manual)");
    print "</li>";

    print "<li>";
    $newloc = "https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}".
              "/cgi-bin/HPCALE_XJDHELPER/gen_semiauto.cgi?".
              "mode=autonew&eletype=component";
    print $cgi->a({-href=>"$newloc", -target=>'main'}, "new comp (semi-auto)");
    print "</li>";
    print "</ul>";
}
                       
sub showComponents {
    my $prevXJD = shift;
    my $showXJDComp = shift;

    my $newloc = "";    
    
    print "<h4>Components</h4>";

    &showNewComp;
    
    if($showXJDComp == 0){
        return;
    }
    print "<ul>";
    if($prevXJD->{rc}->{components} eq ''){
       print "</ul>";
       return;
    }
    
    while ( my ($k, $v) = each(%{$prevXJD->{rc}->{components}->{component}}) ) {
        print "<li>";
        
        my $name = $v->{name};
        
        $newloc = "https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}".
                  "/cgi-bin/HPCALE_XJDHELPER/gen_semiauto.cgi?".
                  "mode=modify_detail&id=$k&eletype=component";
        print $cgi->a({-href=>"$newloc", -target=>'main'}, $k.":".$name);
        print "</li>";
    }
    print "</ul>";
}

sub showNewConn {
    print "<ul>";

    print "<li>";
    my $newloc = "https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}".
              "/cgi-bin/HPCALE_XJDHELPER/gen_semiauto.cgi?".
              "mode=autonew&eletype=connection";
    print $cgi->a({-href=>"$newloc", -target=>'main'}, "new connection");
    print "</li>";
    print "</ul>";
}

sub showConnections {
    my $prevXJD = shift;
    my $showXJDConn = shift;
    my $newloc = "";    
    
    print "<h4>Connections</h4>";
    
    &showNewConn;

    if($showXJDConn == 0){
        return;
    }
  
    if(defined $prevXJD->{rc}->{connections}){
        print "<ul>";
        if($prevXJD->{rc}->{connections} eq ''){
            print "</ul>";
            return;
        }
    }
    
    while ( my ($k, $v) = each(%{$prevXJD->{rc}->{connections}->{connection}}) ) {
        print "<li>";

        my $exp = $v->{exporter};
        my $imp = $v->{importer};

        my $newloc = "https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}".
                     "/cgi-bin/HPCALE_XJDHELPER/gen_semiauto.cgi?".
                     "mode=modify_detail&id=$k&eletype=connection";
        print $cgi->a({-href=>"$newloc", -target=>'main'}, $k.":".$exp."-".$imp);
        print "</li>";
    }
    print "</ul>";
}   
