# 
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

use strict;
use CGI qw(:standard);
use CGI::Carp;
use Cwd;
use Data::Dumper;
use PerlDB;
use show_initial;
use show_autonew;
use show_edit;
use show_detail;
use show_modify_detail;
use show_waitmodify;
use show_remove;
use utilfunc;
use XJDWriter;
use XJDParser;

my $cgi = new CGI;

print $cgi->header();

if(! defined $cgi->param('mode')){
    print $cgi->start_html(-title=>'XJD creation page',
                           -author=>'iyoon@cs.umd.edu',
                           -base=>'true',
                           -meta=>{'copyright'=>'copyright 2005 University of Maryland, College Park'},
                           -script=>{-language=>'JAVASCRIPT',
                                     -src=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/util.js"}
                           );
}
else{
    if($cgi->param('mode') eq "waitmodify" || $cgi->param('mode') eq "remove"){
        print $cgi->start_html(-title=>'XJD creation page',
                               -author=>'iyoon@cs.umd.edu',
                               -base=>'true',
                               -meta=>{'copyright'=>'copyright 2005 University of Maryland, College Park'},
                               -script=>{-language=>'JAVASCRIPT',
                                         -src=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/util.js"},
                               -onload=>"reloadElemlist()"
                               );
    }
    else{
        print $cgi->start_html(-title=>'XJD creation page',
                               -author=>'iyoon@cs.umd.edu',
                               -base=>'true',
                               -meta=>{'copyright'=>'copyright 2005 University of Maryland, College Park'},
                               -script=>{-language=>'JAVASCRIPT',
                                         -src=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/util.js"}
                               );
    }
}

if(! defined $cgi->param('mode')){
    (new show_initial)->showContents ($cgi) ;
}
elsif($cgi->param('mode') eq "waitmodify"){
    (new show_waitmodify)->showContents ($cgi) ;
}
elsif($cgi->param('mode') eq "autonew"){
    (new show_autonew)->showContents ($cgi) ;
}
elsif($cgi->param('mode') eq "edit"){
    (new show_edit)->showContents ($cgi) ;
}
elsif($cgi->param('mode') eq "detail"){
    (new show_detail)->showContents ($cgi) ;
}
elsif($cgi->param('mode') eq "modify_detail"){
    (new show_modify_detail)->showContents ($cgi) ;
}
elsif($cgi->param('mode') eq "initial"){
    (new show_initial)->showContents ($cgi) ;
}
elsif($cgi->param('mode') eq "remove"){
    (new show_remove)->showContents ($cgi) ;
}

print $cgi->end_html;

