#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package show_autonew;

use PerlDB;
use utilfunc;
use show_conn;
use XJDParser;
use Data::Dumper;
use strict;

sub new {
    my $classname  = shift;         # What class are we constructing?
    my $self   = {};                # Allocate new memory
    bless($self, $classname);       # Mark it of the right type
    return $self;
}

sub showContents {
    my $self = shift;
    my $cgi = shift;

    unless(defined $cgi->param('eletype')){
        print "Element Type is not defined.";
        return;
    }
    
    my $eletype = $cgi->param('eletype');
    #&utilfunc::print_params($cgi);
    
    if($eletype eq "component"){        
        &showComponent ($cgi);
    }
    elsif($eletype eq "connection"){
        &show_conn::showConnection ($cgi);
    }  
}

sub showComponent {
    my $cgi = shift;
    
    print $cgi->h1('Search Component');

    #&utilfunc::print_params($cgi);

    print $cgi->start_form(-name=>'initpage',
                           -onsubmit=>"return validate_searchpage(this)");

    print $cgi->hidden(-name=>'eletype', -default=>"component");
    print $cgi->hidden(-name=>'database', -default=>"$ENV{DB_SERVER}");
    print $cgi->hidden(-name=>'mode', -default=>"autonew");
    
    print "Type the unique id of XJD component ? (e.g. comp1) ",$cgi->textfield(-name=>'id');
    print "<p>";
    print "Search component: ", $cgi->textfield(-name=>'compname');
    print "<p>";
    print $cgi->submit(-value=>'Search...', -onClick=>"autonew2edit(initpage)");
        
    print $cgi->end_form;
        
    print $cgi->hr;
}

1;
