#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package show_conn;

use PerlDB;
use utilfunc;
use XJDParser;
use Data::Dumper;
use strict;

sub showConnection {
    my $cgi = shift;
    
    my $sessionid = &utilfunc::get_session_id($cgi);

    print $cgi->h1("Make connection between components.");

    # test code
    #&utilfunc::print_params($cgi);

    unless(-e "$ENV{HTDOCS_HOME}/HPCALE_XJDHELPER/sessions/$sessionid.xjd"){
        print "No XJD corresponding to $sessionid. <br>";
        return;   
    }

    my $prevXJD = new XJDParser("$ENV{HTDOCS_HOME}/HPCALE_XJDHELPER/sessions/$sessionid.xjd", 2);

    my @comparr = ();   
    while ( my ($k, $v) = each(%{$prevXJD->{rc}->{components}->{component}}) ) {
        push @comparr, [$k, $v->{name}, $v->{rcid}];
    }

    my @exdataport = ();
    my @imdataport = ();

    my $perldb = new PerlDB();

    foreach(@comparr){
        my $uniqueid = $_->[0];
        my $name = $_->[1];
        my $rc_id = $_->[2];

        my $query = "SELECT id FROM component WHERE compID = '$name' AND rc_id = $rc_id";
        my $cid = $perldb->select($query)->[0];

        next if(! defined $cid);
        next if(length($cid) == 0);

        $query = "SELECT port_name, port_type FROM dataport WHERE component_id = $cid";
        my $compref = $perldb->multcol_select($query);
        if(not defined $compref){
           next;
        }
        my @comparray = @{$compref};

        foreach(@comparray){
            my $pname = $_->[0];
            my $ptype = $_->[1];

            if($ptype eq "export"){
                push @exdataport, [$uniqueid, $pname];
            }
            elsif($ptype eq "import"){
                push @imdataport, [$uniqueid, $pname];
            }

        }
    }
    
    print "<script type=\"text/javascript\" language=\"javascript\">\n";
    print "<!--\n";
    print "var complist = Array(".scalar @comparr.");\n";
    print "var exportlist = Array(".scalar @exdataport.");\n";
    print "var exportcomplist = Array(".scalar @exdataport.");\n";
    print "var importlist = Array(".scalar @imdataport.");\n";
    print "var importcomplist = Array(".scalar @imdataport.");\n";
     
    my $i=0;
    foreach(@comparr){
        print "complist[$i] = \"$_->[0]\"\n";
        $i++; 
    }
    $i=0;
    foreach(@exdataport){
        print "exportlist[$i] = \"$_->[1]\";\n";
        print "exportcomplist[$i] = \"$_->[0]\";\n";
        $i++;
    }
    $i=0;
    foreach(@imdataport){
        print "importlist[$i] = \"$_->[1]\";\n";
        print "importcomplist[$i] = \"$_->[0]\";\n";
        $i++;
    }

    &write_updatefunctions ;
    
    print "//-->\n";
    print "</script>\n";
    
    $perldb->db_end ;

    
    # For display in popup-menu 
    my @carr = ();
    my %clabel=();
    foreach(@comparr){
        push @carr, $_->[0];
        $clabel{$_->[0]} = "$_->[0] : $_->[1]";
    }

    # For initial display in popup-menu 
    my @exarr = ();
    foreach(@exdataport){
        if($_->[0] eq $comparr[0]->[0]){
            push @exarr, $_->[1];
        }
    }

    # For initial display in popup-menu 
    my @imarr = ();
    foreach(@imdataport){
        if($_->[0] eq $comparr[0]->[0]){
            push @imarr, $_->[1];
        }
    }

    print $cgi->start_form(-name=>'save_conn',
                           -onsubmit=>"return validate_conn(this)");

    print $cgi->hidden(-name=>'mode', -default=>"conn");
    print $cgi->hidden(-name=>'eletype', -default=>"connection");

    print $cgi->start_table({-border => 1});
    
    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_connid.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_connid.html')"},
                           "Connection ID"));
    print $cgi->td($cgi->textfield( -name=>'connid',
                                    -value=>'',
                                    -size=>20,
                                    -maxlength=>20));
    print $cgi->end_Tr();

    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_exporter.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_exporter.html')"},
                           "Exporter"));
    print $cgi->td($cgi->popup_menu(-name=>'excomp',
                                    -values=>[@carr],
                                    -default=>$carr[0],
                                    -labels=>\%clabel,
                                    -onchange=>"change_exporter(this.form)",
                                    -onselect=>"change_exporter(this.form)"));
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_expport.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_expport.html')"},
                           "Export Port"));
    print $cgi->td($cgi->popup_menu(-name=>'exdataport',
                                    -values=>[@exarr]));
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_importer.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_importer.html')"},
                           "Importer"));
    print $cgi->td($cgi->popup_menu(-name=>'imcomp',
                                    -values=>[@carr],
                                    -default=>$carr[0],
                                    -labels=>\%clabel,
                                    -onchange=>"change_importer(this.form)",
                                    -onselect=>"change_importer(this.form)"));
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_impport.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_impport.html')"},
                           "Import Port"));
    print $cgi->td($cgi->popup_menu(-name=>'imdataport',
                                    -values=>[@imarr]));
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_msgtag.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_msgtag.html')"},
                           "Message Tag"));
    print $cgi->td($cgi->textfield( -name=>'msgtag',
                                    -value=>'',
                                    -size=>20,
                                    -maxlength=>20));
    print $cgi->end_Tr();

   # data type
    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_datatype.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_datatype.html')"},
                           "Data Type"));
    print $cgi->td($cgi->popup_menu(-name=>'datatype',
                                    -values=>['int','short','char','float','double'],
                                    -default=>'int'));
    print $cgi->end_Tr();

   # comm type
    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_commtype.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_commtype.html')"},
                           "Communication Type"));
    print $cgi->td($cgi->popup_menu(-name=>'commtype',
                                    -values=>['MxN','1xN'],
                                    -default=>'MxN'));
    print $cgi->end_Tr();

    print $cgi->end_table();

    print $cgi->submit(-name=>'submit', -value=>'Save Connection', -onClick=>"document.pressed=this.value"); 
    
    print $cgi->end_form;          
}


sub write_updatefunctions {
print<<UPDATEFUNCTION; 

    function change_exporter (f){
        var value;
        
        for ( var i = 0; i < f.excomp.options.length; ++i ) {
            if( f.excomp.options[i].selected ) {
                value = f.excomp.options[i].value;
            }
        }
    
        var n = 0;
        f.exdataport.options.length = 0;
        for( var i = 0 ; i < exportcomplist.length ; ++i) {
            if(exportcomplist[i] == value){
                f.exdataport.options[n] = new Option(exportlist[i]);
                ++n;
            }    
        }
        f.exdataport.options[0].selected = true;
    }
        
    function change_importer (f){
        var value;
        
        for ( var i = 0; i < f.imcomp.options.length; ++i ) {
            if( f.imcomp.options[i].selected ) {
                value = f.imcomp.options[i].value;
            }
        }
    
        var n = 0;
        f.imdataport.options.length = 0;
        for( var i = 0 ; i < importcomplist.length ; ++i) {
            if(importcomplist[i] == value){
                f.imdataport.options[n] = new Option(importlist[i]);
                ++n;
            }    
        }
        f.imdataport.options[0].selected = true;
    }

UPDATEFUNCTION
}

1;
