#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package show_detail;

use PerlDB;
use utilfunc;
use XJDParser;
use Data::Dumper;
use strict;

sub new {
    my $classname  = shift;         # What class are we constructing?
    my $self   = {};                # Allocate new memory
    bless($self, $classname);       # Mark it of the right type
    return $self;
}

sub showContents {
    my $self = shift;
    my $cgi = shift;

    print $cgi->h1("Edit Component Detail.");
    #&utilfunc::print_params($cgi);

    print $cgi->start_form(-name=>'compdetail');

    print $cgi->hidden(-name=>"eletype", -default=>"component");

    my $selected = "";
    my $compid;
    my $rcid;
    
    foreach($cgi->param){
        my $value = $cgi->param("$_");
        if($_ =~ /.+.choice/){
            $selected = $_;        
        }
        else{
            print $cgi->hidden(-name=>"$_", -default=>$value);
        }
    }

    if(length($selected) == 0){
        print "NOTHING SELECTED\n";
        print $cgi->end_form;
    	print $cgi->hr;
        return;        
    }
    
    my @arr = split /\./ , $selected;
    $compid = $arr[0];
    $rcid = $arr[1];

    # Query to selected database (uniquely selected)   	
    my $perldb = new PerlDB();

    my $query = "SELECT * FROM component WHERE compID='$compid' AND rc_id=$rcid";
    my $comp = $perldb->multcol_select($query)->[0];
    
    print $cgi->hidden(-name=>"name", -default=>$comp->[1]);    
    print $cgi->hidden(-name=>"rcid", -default=>$comp->[2]);    
    print $cgi->hidden(-name=>"path", -default=>$comp->[3]);    
    print $cgi->hidden(-name=>"file", -default=>$comp->[4]);    
    print $cgi->hidden(-name=>"type", -default=>$comp->[5]);    
    print $cgi->hidden(-name=>"parallel", -default=>$comp->[6]);    
    
    print $cgi->start_table({-border => 1});
    
    print $cgi->start_Tr({-align=>'center', -valign=>'middle'});
    print $cgi->td("Element");
    print $cgi->td("Value");
    print $cgi->end_Tr;

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_id.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_id.html')"},
                          "ID"));
    print $cgi->td($cgi->param('id'));
    print $cgi->end_Tr();
    
    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_name.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_name.html')"},
                           "Name"));
    print $cgi->td($comp->[1]);
    print $cgi->end_Tr();
    
    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_type.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_type.html')"},
                           "Type"));
    print $cgi->td($comp->[5]);
    print $cgi->end_Tr();


    # Get RC Type
    $query = "SELECT rctype_id FROM resource WHERE rc_id = $rcid";
    my $rctypeid = $perldb->select($query)->[0];
    $query = "SELECT type_name FROM rctype WHERE type_id = $rctypeid";
    my $rctype = $perldb->select($query)->[0];

    if($rctype eq "cluster"){
        print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
        print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_cluster.html", 
                                -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_cluster.html')"},
                               "Cluster"));
        $query = "SELECT clst_name FROM cluster WHERE rc_id = $rcid";
        my $clstname = $perldb->select($query)->[0];
        print $cgi->td($clstname);
        print $cgi->end_Tr();

        print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
        print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_nNode.html", 
                                -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_nNode.html')"},
                               "Number of Nodes"));
        print $cgi->td($cgi->textfield( -name=>'nNode',
                                        -value=>'',
                                        -size=>50,
                                        -maxlength=>80));
        print $cgi->end_Tr();

        print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
        print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_sched.html", 
                                -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_sched.html')"},
                               "Scheduler"));
        $query = "SELECT scheduler FROM cluster WHERE rc_id = $rcid";
        my $scheduler = $perldb->select($query)->[0];
        print $cgi->td("$scheduler");
        print $cgi->end_Tr();

        if($scheduler eq "SSH"){
            print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
            print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_nodeset.html", 
                                    -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_nodeset.html')"},
                                   "NodeSet"));
            print $cgi->td($cgi->textfield( -name=>'nodeset',
                                            -value=>'',
                                            -size=>50,
                                            -maxlength=>80));
            print $cgi->end_Tr();
        }

        $query = "SELECT mgr_id FROM resource WHERE rc_id = $rcid";
        my $mgrid = $perldb->select($query)->[0];
        $query = "SELECT mgr_host FROM rcmgr WHERE mgr_id = $mgrid";
        my $mgr = $perldb->select($query)->[0];        

        print $cgi->hidden(-name=>"rctype", -default=>"cluster");    
        print $cgi->hidden(-name=>"cluster", -default=>$clstname);    
        print $cgi->hidden(-name=>"scheduler", -default=>$scheduler);    
        print $cgi->hidden(-name=>"head", -default=>$mgr);    

        
    }
    elsif($rctype eq "node"){
        print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
        print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_node.html", 
                                -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_node.html')"},
                               "Nodename"));
        $query = "SELECT node_name, domain FROM node WHERE rc_id = $rcid";
        my $aNode = $perldb->multcol_select($query)->[0];
        my $nodename = $aNode->[0];
        my $domain = $aNode->[1];
        print $cgi->td($nodename.".".$domain);
        print $cgi->end_Tr();

        print $cgi->hidden(-name=>"rctype", -default=>"node");    
        print $cgi->hidden(-name=>'node', -default=>$nodename);
        print $cgi->hidden(-name=>'domain', -default=>$domain);
        print $cgi->hidden(-name=>'head', -default=>$nodename.".".$domain);
    }

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_parallel.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_parallel.html')"},
                           "Parallel"));

    if($comp->[6] eq "1"){        # Parallel
        print $cgi->td("Y");
    }
    else{
        print $cgi->td("N");
    }         
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_argument.html", 
                           -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_argument.html')"},
                           'Argument'));
                            
    print $cgi->td($cgi->textfield( -name=>'argument',
                                    -value=>'',
                                    -size=>50,
                                    -maxlength=>255));
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_launchdir.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_launchdir.html')"},
                           "Launch Directory"));
    print $cgi->td($cgi->textfield( -name=>'launchdir',
                                    -value=>'',
                                    -size=>50,
                                    -maxlength=>80));
    print $cgi->end_Tr();


    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_launchprog.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_launchprog.html')"},
                           "Launch Program"));
    print $cgi->td($cgi->textfield( -name=>'launchprog',
                                    -value=>$comp->[7],
                                    -size=>50,
                                    -maxlength=>80));
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_launcharg.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_launcharg.html')"},
                           "Launch Argument"));
    print $cgi->td($cgi->textfield( -name=>'launcharg',
                                    -value=>$comp->[8],
                                    -size=>50,
                                    -maxlength=>80));
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_sfilelist.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_sfilelist.html')"},
                           "Send Filelist"));
    print $cgi->td($cgi->textfield( -name=>'sendfiles',
                                    -value=>'',
                                    -size=>50,
                                    -maxlength=>80));
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_rfilelist.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_rfilelist.html')"},
                           "Receive Filelist"));
    print $cgi->td($cgi->textfield( -name=>'recvfiles',
                                    -value=>'',
                                    -size=>50,
                                    -maxlength=>80));
    print $cgi->end_Tr();

    print $cgi->end_table();
    print "<br>";
    
    print $cgi->submit(-value=>'Save Component', -onClick=>"detail2waitmodify(compdetail)");

    print $cgi->end_form;
	print $cgi->hr;
    
    $perldb->db_end ;
}

1;
