#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package show_edit;

use PerlDB;
use utilfunc;
use XJDParser;
use Data::Dumper;
use strict;

sub new {
    my $classname  = shift;         # What class are we constructing?
    my $self   = {};                # Allocate new memory
    bless($self, $classname);       # Mark it of the right type
    return $self;
}

sub showContents {
    my $self = shift;
    my $cgi = shift;
        
    print $cgi->h1('Select Component');

    #&utilfunc::print_params($cgi);

    print "XJD component ID is ",$cgi->em($cgi->param('id')), $cgi->p, "Repository, ", $cgi->em($cgi->param('database')), " will be used.", $cgi->hr;
	
	# retrieve selectively from database using SQL pattern matching.
	# modify the regular expression mark to MySQL pattern matching style.
	my $compname = $cgi->param('compname');

   if(length(&utilfunc::trimwhitespace($compname)) == 0){
      print "You must give string to find component";
      return;
   }

	$compname =~ s/\*/%/g;
	$compname =~ s/\?/_/g;

    # Query to selected database    	
    my $perldb = new PerlDB();

    my $query = "SELECT compID,rc_id,type,parallel FROM component WHERE compID LIKE '$compname'";
    my @comparray = @{$perldb->multcol_select($query)};

    print $cgi->start_form(-name=>'comptable',
                           -onsubmit=>"return validate_onlyone_checked(this)");
    
    print $cgi->hidden(-name=>'mode', -default=>"edit");
    print $cgi->hidden(-name=>'id', -default=>$cgi->param('id'));
    print $cgi->hidden(-name=>'database', -default=>$cgi->param('database'));


    print $cgi->start_table({-border => 1});
    print $cgi->start_Tr({-align=>'center', -valign=>'middle'});
    print $cgi->td("Select");
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_name.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_name.html')"},
                           "CompName"));
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_type.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_type.html')"},
                           "Type"));
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_parallel.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_parallel.html')"},
                           "Parallel"));
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_rctype.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_rctype.html')"},
                           "RC Type"));
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_rcname.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_rcname.html')"},
                           "RC Name"));
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_rccontroller.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_rccontroller.html')"},
                           "RC Controller"));
    print $cgi->end_Tr;

    foreach(@comparray){
        print $cgi->start_Tr({-align=>'center', -valign=>'middle'});
       
        my $identifier = "$_->[0].$_->[1]";
        print $cgi->td($cgi->checkbox(-name=>"$identifier.choice",
                                      -checked=>0,
                                      -value=>1,
                                      -label=>'')); # selection checkbox
          
        my $linkname = "$_->[0].html";
        print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/swdesc/$linkname",
                                -onClick=>"return popup_swinfo('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_REPMAN/swdesc/$linkname')"},
                                "$_->[0]")); # compID

        print $cgi->td("$_->[2]"); # type
              
        if($_->[3] eq "1"){        # Parallel
            print $cgi->td("Y");
        }
        else{
            print $cgi->td("N");
        }         
        
        print $cgi->td($_->[4]);   # XJD Option
        
        $query = "SELECT rctype_id FROM resource WHERE rc_id = $_->[1]";
        my $rctypeid = $perldb->select($query)->[0];

        $query = "SELECT type_name FROM rctype WHERE type_id = $rctypeid";
        my $rctype = $perldb->select($query)->[0];
        print $cgi->td("$rctype"); # RC Type

        if($rctype eq "cluster"){
            $query = "SELECT clst_name FROM cluster WHERE rc_id = $_->[1]";
            my $clstname = $perldb->select($query)->[0];
            print $cgi->td("$clstname");

            $query = "SELECT scheduler FROM cluster WHERE rc_id = $_->[1]";
            my $scheduler = $perldb->select($query)->[0];
            print $cgi->td("$scheduler");
        }
        elsif($rctype eq "node"){
            $query = "SELECT node_name FROM node WHERE rc_id = $_->[1]";
            my $nodename = $perldb->select($query)->[0];
            print $cgi->td("$nodename");
            print $cgi->td("SSH");
        }
            
        print $cgi->end_Tr;
    }
    print $cgi->end_table;

    print $cgi->submit(-value=>'Edit detail...', -onClick=>"edit2detail(comptable)");
    print $cgi->end_form;
	print $cgi->hr;
    
    $perldb->db_end ;
}

1;
