#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package show_mannew;

use PerlDB;
use utilfunc;
use show_conn;
use XJDParser;
use Data::Dumper;
use strict;

sub new {
    my $classname  = shift;         # What class are we constructing?
    my $self   = {};                # Allocate new memory
    bless($self, $classname);       # Mark it of the right type
    return $self;
}

sub showContents {
    my $self = shift;
    my $cgi = shift;

    unless(defined $cgi->param('eletype')){
        print "Element Type is not defined.";
        return;
    }
    
    my $eletype = $cgi->param('eletype');
    
    if($eletype eq "component"){        
        &showComponent ($cgi);
    }
    elsif($eletype eq "connection"){
        &show_conn::showConnection ($cgi);
    }  
}


sub showComponent {
    my $cgi = shift;
    
    print $cgi->h1("Manually Create New Component.");

    #&utilfunc::print_params($cgi);

    print $cgi->start_form(-name=>'mannewdetail',
                           -onsubmit=>"return validate_manualcomp(this)");

    print $cgi->hidden(-name=>'eletype', -default=>"component");
    print $cgi->hidden(-name=>'database', -default=>"$ENV{APACHE_SERVER}");
    print $cgi->hidden(-name=>'mode', -default=>"mannew");
    
    print "<script type=\"text/javascript\" language=\"javascript\">\n";
    print "<!--\n";
    &write_update_rcdetail ;
    print "//-->\n";
    print "</script>\n";    

    
    print $cgi->start_table({-border => 1, -id => 'comptable'});
    
    &utilfunc::printEmptyRow ($cgi, 1, "Element", "Value", "");
    &utilfunc::printEmptyTextField($cgi, "ID", "id", 50, 80, "desc_id");
    
    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_repository.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_repository.html')"},
                           "Repository"));
    print $cgi->td({-align=>'left'}, $cgi->popup_menu(-name=>'database', -values=>['redleader.umiacs.umd.edu']));
    print $cgi->end_Tr();

    &utilfunc::printEmptyTextField($cgi, "Name", "name", 50, 80, "desc_name");

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_parallel.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_parallel.html')"},
                           "Parallel"));
    print $cgi->td({-align=>'left'}, $cgi->popup_menu(-name=>'parallel', 
                                    -values=>['Y','N']));
    print $cgi->end_Tr();
    
    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_type.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_type.html')"},
                           "Type"));
    print $cgi->td({-align=>'left'}, $cgi->popup_menu(-name=>'type', 
                                    -values=>['MPI-executable', 'PVM-executable', 'Executable', 'OpenMP-executable'],
                                    -onchange=>"change_exectype(this.form)",
                                    -onselect=>"change_exectype(this.form)"));
    print $cgi->end_Tr();

    print $cgi->start_Tr({-align=>'left', -valign=>'middle'});
    print $cgi->td($cgi->a({-href=>"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_rctype.html", 
                            -onClick=>"return popup('https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_rctype.html')"},
                           "RC Type"));
    print $cgi->td({-align=>'left'}, $cgi->popup_menu(-name=>'rctype', 
                                    -values=>['','cluster','node'],
                                    -onchange=>"change_rctype(this.form)",
                                    -onselect=>"change_rctype(this.form)"));
    print $cgi->end_Tr();

    &utilfunc::printEmptyTextField($cgi, "Path", "path", 50, 80, "desc_path");
    &utilfunc::printEmptyTextField($cgi, "File", "file", 50, 80, "desc_file");
    &utilfunc::printEmptyTextField($cgi, "Argument", "argument", 50, 255, "desc_argument");
    &utilfunc::printEmptyTextField($cgi, "Launch Directory", "launchdir", 50, 80, "desc_launchdir");
    &utilfunc::printEmptyTextField($cgi, "Launch Program", "launchprog", 50, 80, "desc_launchprog");
    &utilfunc::printEmptyTextField($cgi, "Launch Argument", "launcharg", 50, 80, "desc_launcharg");
    &utilfunc::printEmptyTextField($cgi, "Send Filelist", "sendfiles", 50, 80, "desc_sfilelist");
    &utilfunc::printEmptyTextField($cgi, "Receive Filelist", "recvfiles", 50, 80, "desc_rfilelist");
    print $cgi->end_table();

    print $cgi->submit(-value=>'Save Component', -onClick=>"mannew2waitmodify(mannewdetail)");

    print $cgi->end_form;
    print $cgi->hr;  
}

sub write_update_rcdetail {

print<<UPDATERCDETAIL;

    function change_exectype (f)
    {
        var value;

        for ( var i = 0; i < f.type.options.length; ++i ) {
            if( f.type.options[i].selected ) {
                value = f.type.options[i].value;

                if(value == 'Executable'){
                    del_nNode();
                    f.parallel.options[1].selected = true;
                }
            }
        }
    }

    function change_rctype (f)
    {
        var value;

        for ( var i = 0; i < f.rctype.options.length; ++i ) {
            if( f.rctype.options[i].selected ) {
                value = f.rctype.options[i].value;

                if(value == 'cluster'){
                    del_nodename();
                
                    ins_sched_cluster();
                    ins_nNode();
                }
                else if(value == 'node'){
                    del_nNode();
                    del_clusterhead();
                    del_clustername();
                    del_nodeset();
                    del_sched_cluster();
                    
                    ins_nodename();
                }
            }
        }
    }

    function change_sched(f)
    {
        var value;
        for ( var i = 0; i < f.scheduler.options.length; ++i ) {
            if( f.scheduler.options[i].selected ) {
                value = f.scheduler.options[i].value;

                ins_clustername();
                ins_clusterhead();

                if(value == 'SSH'){
                    ins_nodeset();
                }
                else{
                    del_nodeset();
                }
            }
        }
    }

    function ins_nodename()
    {
        var rows = document.getElementById('comptable').rows;
        var tRow = -1;
        for ( var j = 0 ; j < rows.length ; ++j ) {
            var cols = rows[j].cells;
            if(cols[0].innerHTML.search('RC Type') >= 0){
                tRow = j+1;
            }
        }
    
        var table = document.getElementById('comptable').insertRow(tRow);
        var n = table.insertCell(0);
        n.innerHTML = "<a href=\\\"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_node.html\\\", target= \\\"desc\\\">Nodename</a>";
        n.align = "left";

        var v = table.insertCell(1);
        v.innerHTML = "<input type='text' name='head' size='50' maxlength='80' />";
    }

    function ins_nNode()
    {
        var rows = document.getElementById('comptable').rows;
        
        for ( var i = 0 ; i < rows.length ; ++i ) {
            var cols = rows[i].cells;
            if(cols[0].innerHTML.search('Number of Nodes') >= 0){
                return;
            }
        }
    
        var tRow = -1;
        for ( var j = 0 ; j < rows.length ; ++j ) {
            var cols = rows[j].cells;
            if(cols[0].innerHTML.search('Scheduler') >= 0){
                tRow = j+1;
            }
        }

        var table = document.getElementById('comptable').insertRow(tRow);
        var n = table.insertCell(0);
        n.innerHTML = "<a href=\\\"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_nNode.html\\\", target= \\\"desc\\\">Number of Nodes</a>";
        n.align = "left";

        var v = table.insertCell(1);
        v.innerHTML = "<input type='text' name='nNode' size='50' maxlength='80' />";
    }

    function ins_clustername()
    {
        var rows = document.getElementById('comptable').rows;
        for ( var i = 0 ; i < rows.length ; ++i ) {
            var cols = rows[i].cells;
            if(cols[0].innerHTML.search('ClusterName') >= 0){
                return;
            }
        }

        var tRow = -1;
        for ( var i = 0 ; i < rows.length ; ++i ) {
            var cols = rows[i].cells;
            if(cols[0].innerHTML.search('Number of Nodes') >= 0){
                tRow = i+1;
            }
        }

        var table = document.getElementById('comptable').insertRow(tRow);
        var n = table.insertCell(0);
        n.innerHTML = "<a href=\\\"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_cluster.html\\\", target= \\\"desc\\\">ClusterName</a>";
        n.align = "left";

        var v = table.insertCell(1);
        v.innerHTML = "<input type='text' name='cluster' size='50' maxlength='80' />";
    }

    function ins_clusterhead()
    {
        var rows = document.getElementById('comptable').rows;
        for ( var i = 0 ; i < rows.length ; ++i ) {
            var cols = rows[i].cells;
            if(cols[0].innerHTML.search('ClusterHead') >= 0){
                return;
            }
        }

        var tRow = -1;
        for ( var i = 0 ; i < rows.length ; ++i ) {
            var cols = rows[i].cells;
            if(cols[0].innerHTML.search('ClusterName') >= 0){
                tRow = i+1;
            }
        }

        var table = document.getElementById('comptable').insertRow(tRow);
        var n = table.insertCell(0);
        n.innerHTML = "<a href=\\\"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_clusterhead.html\\\", target= \\\"desc\\\">ClusterHead</a>";
        n.align = "left";

        var v = table.insertCell(1);
        v.innerHTML = "<input type='text' name='head' size='50' maxlength='80' />";
    }

    function ins_nodeset()
    {
        var rows = document.getElementById('comptable').rows;
        var tRow = -1;
        for ( var i = 0 ; i < rows.length ; ++i ) {
            var cols = rows[i].cells;
            if(cols[0].innerHTML.search('ClusterHead') >= 0){
                tRow = i+1;
            }
        }

        var table = document.getElementById('comptable').insertRow(tRow);
        var n = table.insertCell(0);
        n.innerHTML = "<a href=\\\"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_nodeset.html\\\", target= \\\"desc\\\">NodeSet</a>";
        n.align = "left";

        var v = table.insertCell(1);
        v.innerHTML = "<input type='text' name='nodeset' size='50' maxlength='80' />";
    }

    function ins_sched_cluster()
    {
        var rows = document.getElementById('comptable').rows;
        var tRow = -1;
        for ( var j = 0 ; j < rows.length ; ++j ) {
            var cols = rows[j].cells;
            if(cols[0].innerHTML.search('RC Type') >= 0){
            
                tRow = j+1;
            }
        }

        var table = document.getElementById('comptable').insertRow(tRow);
        var n = table.insertCell(0);
        var v = table.insertCell(1);
        n.innerHTML = "<a href=\\\"https://$ENV{APACHE_SERVER}:$ENV{APACHE_PORT}/HPCALE_XJDHELPER/desc/desc_sched.html\\\", target= \\\"desc\\\">Scheduler</a>";
        n.align = "left";

        var str = "<select name='scheduler' onchange=change_sched(this.form) onselect=change_sched(this.form)>";
        var schedtypes = new Array("","SSH","PBS","LSF","LoadLeveler");
        for ( var i = 0 ; i < schedtypes.length ; ++i ) {
            str = str.concat("<option value=");
            str = str.concat(schedtypes[i]);
            str = str.concat(">");
            str = str.concat(schedtypes[i]);
            str = str.concat("</option>");
        }
        str = str.concat("</select>");

        v.innerHTML = str;
        v.align = "left";
    }

    function del_sched_cluster()
    {
        del_row_by_content("Scheduler");
    }

    function del_nodeset()
    {
        del_row_by_content("NodeSet");
    }

    function del_nNode()
    {
        del_row_by_content("Number of Nodes");
    }
    
    function del_nodename()
    {
        del_row_by_content("NodeName");
    }
    
    function del_clustername()
    {
        del_row_by_content("ClusterName");
    }

    function del_clusterhead()
    {
        del_row_by_content("ClusterHead");
    }


    function del_row_by_content(contents)
    {
        var rows = document.getElementById('comptable').rows;
        for ( var i = 0 ; i < rows.length ; ++i ) {
            var cols = rows[i].cells;
            if(cols[0].innerHTML.search(contents) >= 0){
                document.getElementById('comptable').deleteRow(i);
            }
        }
    }

UPDATERCDETAIL
}

1;
