#
# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package show_remove;

use PerlDB;
use utilfunc;
use XJDParser;
use XJDWriter;
use Data::Dumper;
use strict;

sub new {
    my $classname  = shift;         # What class are we constructing?
    my $self   = {};                # Allocate new memory
    bless($self, $classname);       # Mark it of the right type
    return $self;
}

sub showContents {
    my $self = shift;
    my $cgi = shift;

    #&utilfunc::print_params($cgi);

    if(defined $cgi->param('eletype')){
        if($cgi->param('eletype') eq "component"){
            print "Component ".$cgi->param('id')." is removed.";
            &removeComponent($cgi, $cgi->param('id'));
        }
        else{
            print "Connection ".$cgi->param('connid')." is removed.";
            &removeConnection($cgi, $cgi->param('connid'));
        }
    }
}

sub removeComponent {
    my $cgi = shift;
    my $id = shift;
    my $sessionid = &utilfunc::get_session_id($cgi);
 
    my $xjd = ();
    $xjd->{ICXJD} = ();
    $xjd->{ICXJD}->{version} = "1.5";
    $xjd->{ICXJD}->{components} = ();
    $xjd->{ICXJD}->{components}->{component} = ();
    $xjd->{ICXJD}->{components}->{component}->{component} = ();
    $xjd->{ICXJD}->{connections} = ();
    $xjd->{ICXJD}->{connections}->{connection} = ();
    $xjd->{ICXJD}->{connections}->{connection}->{connection} = ();
     
    my $DEBUGLEVEL = 2;
    my $prevXJD = new XJDParser("$ENV{HTDOCS_HOME}/HPCALE_XJDHELPER/sessions/$sessionid.xjd", $DEBUGLEVEL);

    my $i = 0;
    unless($prevXJD->{rc}->{components} eq ''){
        while ( my ($k, $v) = each(%{$prevXJD->{rc}->{components}->{component}}) ) {
            unless($k eq $id){
                $xjd->{ICXJD}->{components}->{component}->{component}->{$k} = $v;
                $i++;
            }
        }
    }
    if($i == 0){
        $xjd->{ICXJD}->{components} = '';
    }
    
    # selectively remove connection
    my $j = 0;
    unless($prevXJD->{rc}->{connections} eq ''){
        while ( my ($k, $v) = each(%{$prevXJD->{rc}->{connections}->{connection}}) ) {
            my $exporter = $v->{exporter};
            my $importer = $v->{importer};
            
            if( ($exporter ne $id) && ($importer ne $id)){
                $xjd->{ICXJD}->{connections}->{connection}->{connection}->{$k} = $v;
                $j++;
            }
        }
    }
    if($j == 0){
        $xjd->{ICXJD}->{connections} = '';
    }
        
    (new XJDWriter())->writeXML($xjd, "$ENV{HTDOCS_HOME}/HPCALE_XJDHELPER/sessions/$sessionid.xjd");
}

sub removeConnection {
    my $cgi = shift;
    my $connid = shift;
    my $sessionid = &utilfunc::get_session_id($cgi);
 
    my $xjd = ();
    $xjd->{ICXJD} = ();
    $xjd->{ICXJD}->{version} = "1.5";
    $xjd->{ICXJD}->{connections} = ();
    $xjd->{ICXJD}->{connections}->{connection} = ();
    $xjd->{ICXJD}->{connections}->{connection}->{connection} = ();
     
    my $DEBUGLEVEL = 2;
    my $prevXJD = new XJDParser("$ENV{HTDOCS_HOME}/HPCALE_XJDHELPER/sessions/$sessionid.xjd", $DEBUGLEVEL);

    # preserve the component information    
    $xjd->{ICXJD}->{components} = $prevXJD->{rc}->{components};

    my $i = 0;
    while ( my ($k, $v) = each(%{$prevXJD->{rc}->{connections}->{connection}}) ) {
        unless($k eq $connid){
            $xjd->{ICXJD}->{connections}->{connection}->{connection}->{$k} = $v;
            $i++;
        }
    }

    if($i == 0){
        $xjd->{ICXJD}->{connections} = '';
    }
    
    (new XJDWriter())->writeXML($xjd, "$ENV{HTDOCS_HOME}/HPCALE_XJDHELPER/sessions/$sessionid.xjd");
}


1;
